<?php
//_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
// ***************************************************************
// CLASS_LOG.php
// ***************************************************************
//_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/

//////////////////////////////////////////////////////////////////
// LOG 饹
// 񤭹ޤ줿ǡδԤ饹
//////////////////////////////////////////////////////////////////
class LOG {

    //************************************************************
    // ѿ
    protected $flag_exist;  // ե¸ߥե饰
    protected $path;        // եΥѥ
    protected $data;        // 񤭹ߥǡ
    protected $size;        // 񤭹
    protected $thread_no;   // åNo
    protected $m_count;     // 

    //************************************************************
    // ʲ᥽å

    //////////////////////////////////////////////////////////////
    // 󥹥ȥ饯
    //////////////////////////////////////////////////////////////
    //    : $p   : ɤ߹ǡΥѥ
    //  : ̵
    //////////////////////////////////////////////////////////////
    public function LOG($p = NULL) {
        $this->flag_exist = false;
        $this->path = NULL;
        $this->data = NULL;
        $this->size = 0;
        $this->thread_no = 0;
        $this->m_count = 0;

        if ( $p != NULL ) {
            $this->open($p);
        }
    }

    //////////////////////////////////////////////////////////////
    // եɤ߹
    //////////////////////////////////////////////////////////////
    //    : $p     : ɤ߹ǡΥѥ
    //  : bool
    //////////////////////////////////////////////////////////////
    public function open($p) {
        // ե뤬¸ߤ뤫ǽ˳ǧ
        if ( !file_exists($p) ) {
            return false;
        }

        // ѥ¸
        $this->path = $p;
        // ǡ
        $this->data = file($p);
        // åNo
        $this->thread_no = intval($this->data[0]);
        // 񤭹߿¸
        $this->size = count($this->data) - 1;
        // ե¸ߥե饰onˤ
        $this->flag_exist = true;

        // ǡƬΥåNoΥǡä
        array_shift($this->data);

        return true;
    }

    //////////////////////////////////////////////////////////////
    // ե̵֤ͭ
    //////////////////////////////////////////////////////////////
    //    : ̵
    //  : $file_exist : ե̵ͭbool֤ͤ
    //////////////////////////////////////////////////////////////
    public function getExist() {
        return $this->flag_exist;
    }

    //////////////////////////////////////////////////////////////
    // եΥ֤
    //////////////////////////////////////////////////////////////
    //    : ̵
    //  : $size : 񤭹ߤο֤
    //////////////////////////////////////////////////////////////
    public function getSize() {
        return $this->size;
    }

    //////////////////////////////////////////////////////////////
    // 񤭹ߥǡȤ֤
    //////////////////////////////////////////////////////////////
    //    : ̵
    //  : $data : 񤭹ߥǡ
    //////////////////////////////////////////////////////////////
    public function getData() {
        return $this->data;
    }

    //////////////////////////////////////////////////////////////
    // åNo֤
    //////////////////////////////////////////////////////////////
    //    : ̵
    //  : $thread_no : åNo
    //////////////////////////////////////////////////////////////
    public function getThreadNo() {
        return $this->thread_no;
    }

    //////////////////////////////////////////////////////////////
    // ꤵ줿ֹν񤭹ߤ֤
    //////////////////////////////////////////////////////////////
    //    : $no  : 񤭹ߤֹ
    //  : $res : ꤵ줿񤭹ߤΥǡ
    //////////////////////////////////////////////////////////////
    public function getRes($no = NULL) {

        $flag_count = false;

        // ֹλ̵꤬󥿤
        if ( $no == NULL ) {
            $no = $this->m_count;
            $flag_count = true;
        }
        
        // ֹ椬ǼƤϰϳʤNULL֤
        if ($no < 0 || $this->size <= $no ) {
            return NULL;
        }

        if ( $this->data[$no] == NULL ) {
            var_dump( $no );
            die("end");
        }

        // ֹν񤭹ߥǡФ
        $res = array();
        list(
            $res['no'],
            $res['title'],
            $res['name'],
            $res['body'],
            $res['date'],
            $res['ip'],
            $res['id'],
            $res['show']
        ) = explode(MARK,trim($this->data[$no]));

        // 󥿤ͤѤƤХ󥿤û
        if ( $flag_count == true ) {
            $this->m_count++;
        }

        return $res;
    }
   
    //////////////////////////////////////////////////////////////
    // ꤵ줿ֹν񤭹ߤԽ
    //////////////////////////////////////////////////////////////
    //  : $res : ꤵ줿񤭹ߤΥǡ
    //    : $no  : 񤭹ߤֹ
    //////////////////////////////////////////////////////////////
    public function editRes($res, $no = NULL) {
        // ͤʤNULL֤
        if ( $res == NULL || $no == NULL ) {
            return;
        }

        // ¸ѤηˤޤȤ
        $response  = $res["no"]    . MARK;
        $response .= $res["title"] . MARK;
        $response .= $res["name"]  . MARK;
        $response .= $res["body"]  . MARK;
        $response .= $res["date"]  . MARK;
        $response .= $res["ip"]    . MARK;
        $response .= $res["id"]    . MARK;
        $response .= $res["show"];

        // ǡ
        $this->data[$no] = $response;
        return true;
    }


    //////////////////////////////////////////////////////////////
    // 񤭹ߤɲä
    //////////////////////////////////////////////////////////////
    //    : $p_name : ̾
    //    : $p_body : ʸ
    //  : ̵
    //////////////////////////////////////////////////////////////
    public function addRes( $p_name, $p_body, $p_title = "" ) {

        $response = "";

        // ()
        $no         = $this->getSize() + 1;                     // 񤭹ֹ
        $title      = $p_title;                                 // åɥȥ
        $name       = ( $p_name != "" ) ? htmlspecialchars($p_name) : NO_NAME;    // ̾
        $body       = htmlspecialchars($p_body);                // ʸ
        $body       = str_replace("\r\n","<br />", $body);
        $body       = str_replace("\n","<br />",   $body);
        $write_date = date("Y-m-d H:i:s");                      // 񤭹
        $ip         = $_SERVER["REMOTE_ADDR"];                  // IP
        if ( isset($_SERVER["REMOTE_HOST"]) ) {                 // ۥ
            $host = $_SERVER["REMOTE_HOST"];
        } else {
            $host = gethostbyaddr($ip);
        }
        $id         = substr(crypt($ip,date("d")),2,10);        // ID
        $show       = FLAG_VISIBLE;                             // ɽե饰
        // (ޤ)

        // ޤȤ
        $response  = $no         . MARK;
        $response .= $title      . MARK;
        $response .= $name       . MARK;
        $response .= $body       . MARK;
        $response .= $write_date . MARK;
        $response .= $host       . MARK;
        $response .= $id         . MARK;
        $response .= $show;

        // ɲ
        $this->data[] = $response;
        $this->size++;
    }

    //////////////////////////////////////////////////////////////
    // ǡ¸
    //////////////////////////////////////////////////////////////
    //    : ̵
    //  : ̵
    //////////////////////////////////////////////////////////////
    public function write() {

        // 񤭹ߥǡޤȤ
        $all = $this->thread_no;
        foreach( $this->data as $value ) {
            $all .= "\n" . trim($value);
        }

        // 񤭹ߥ񤭹
        $fp = fopen($this->path,"w");
        flock($fp,LOCK_EX);
        fwrite($fp,$all);
        flock($fp,LOCK_UN);
        fclose($fp);
    }

    //////////////////////////////////////////////////////////////
    // åɥȥ
    //////////////////////////////////////////////////////////////
    //    : ̵
    //  : ̵
    //////////////////////////////////////////////////////////////
    public function getTitle() {
        $res = $this->getRes(0);
        $title = $res['title'];
        return $title;
    }

}
?>