<?php
//_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
// ***************************************************************
// CLASS_TURN.php
// ***************************************************************
//_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/

//////////////////////////////////////////////////////////////////
// TURN 饹
// åɤɽϿե륯饹
//////////////////////////////////////////////////////////////////
class TURN {
    //************************************************************
    // ѿ
    protected $flag_exist;  // ¸ե뤬¸ߤƤ뤫
    protected $data;        // ֥ǡ
    protected $size;        // ǡο
    protected $path;        // ¸եΥѥ

    //************************************************************
    // ʲ᥽å

    //////////////////////////////////////////////////////////////
    // 󥹥ȥ饯
    //////////////////////////////////////////////////////////////
    //    : $p   : ɤ߹ǡΥѥ
    //  : ̵
    //////////////////////////////////////////////////////////////
    public function TURN( $p = NULL ) {
        // ѿν
        $this->flag_exist = false;
        $this->data = NULL;
        $this->size = 0;
        $this->path = NULL;

        // ȤƥեѥͿƤС
        // ǽ֥ǡɤ߹
        if ( $p != NULL ) {
            $this->path = $p;
            if ( file_exists($p) ) {
                $this->flag_exist = true;
                $this->data       = file($p);
                $this->size       = count( $this->data );
                
                // dataͲ
                for($i=0;$i<$this->size;$i++) {
                    $this->data[$i] = intval($this->data[$i]);
                }
            }
        }
    }

    //////////////////////////////////////////////////////////////
    // ե̵֤ͭ
    //////////////////////////////////////////////////////////////
    //    : ̵
    //  : $file_exist : ե̵ͭbool֤ͤ
    //////////////////////////////////////////////////////////////
    public function getExist() {
        return $this->flag_exist;
    }

    //////////////////////////////////////////////////////////////
    // եΥ֤
    //////////////////////////////////////////////////////////////
    //    : ̵
    //  : $size : åɤο֤
    //////////////////////////////////////////////////////////////
    public function getSize() {
        return $this->size;
    }

    //////////////////////////////////////////////////////////////
    // åɽΥ롼׾֤ͤ
    //////////////////////////////////////////////////////////////
    //    : $start : ܤ뤫ɽ
    //    : $limit : 롼ײξ(ǥեȤ10)
    //  : $cnt   : 롼׾
    //////////////////////////////////////////////////////////////
    public function getLoopLimit($start = 0,$limit = 10) {
        // $startơåɤϻĤ겿ĤΤ׻
        $left = $this->size - $start;

        if ( $left > $limit ) {
            // ĤΥåɿ$limitۤƤ$limitˤ碌
            $cnt = $start + $limit;
        } else {
            // ۤƤʤ$leftˤ碌
            $cnt = $start + $left;
        }
        return $cnt;
    }

    //////////////////////////////////////////////////////////////
    // ֥ǡȤ֤
    //////////////////////////////////////////////////////////////
    //    : ̵
    //  : $data : ǡ
    //////////////////////////////////////////////////////////////
    public function getData() {
        return $this->data;
    }

    //////////////////////////////////////////////////////////////
    // ֥ǡͤ򣱤֤
    //////////////////////////////////////////////////////////////
    //    : $pos   : Ȥ֤ΰ
    //  : $value : Ȥ줿֤
    //////////////////////////////////////////////////////////////
    public function getValue($pos = 0) {
        if ( $pos < 0 || $this->size <= $pos ) {
            return NULL;
        }
        return intval($this->data[$pos]);
    }

    //////////////////////////////////////////////////////////////
    // ֥ǡκͤ򣱤֤
    //////////////////////////////////////////////////////////////
    //    : ̵
    //  : $value : ǡκ
    //////////////////////////////////////////////////////////////
    public function getMaxValue() {
        return intval(max($this->data));
    }

    //////////////////////////////////////////////////////////////
    // ֥ǡ˿ɲäԤ
    //////////////////////////////////////////////////////////////
    //    : ̵
    //  : ̵
    //////////////////////////////////////////////////////////////
    public function addData() {

        // ǡʤȤƽƤ
        if ( $this->data == NULL ) {
            $this->data = array();
            $new_data = 1;
        }
        else {
            $new_data = max($this->data) + 1;
        }

        array_unshift( $this->data, $new_data );
        $this->size++;
        return;
    }

    //////////////////////////////////////////////////////////////
    // ֥ǡλꤷǡ
    // Ȥоݥǡʤƺƹ륤᡼
    //////////////////////////////////////////////////////////////
    //    : $delete_no : оݤν֥ǡֹ
    //  : ̵
    //////////////////////////////////////////////////////////////
    public function deleteData($delete_no) {
        $no = intval($delete_no);
        // Ѱ
        $temp = array();
        foreach($this->data as $value ) {
            // оݤΥǡʤ̵뤹
            if ( $value == $no ) { continue; }
            // Ǥʤͤù
            array_push($temp,$value);
        }
        $this->data = $temp;

        // ǡ
        $this->size = count($this->data);
    }

    //////////////////////////////////////////////////////////////
    // ֥ǡ¸
    //////////////////////////////////////////////////////////////
    //    : ̵
    //  : $res : ݤbool֤ͤ
    //////////////////////////////////////////////////////////////
    public function writeData() {
        if ( $this->path == NULL | $this->path == "" ) {
            // ¸λ̵꤬
            $res = false;
        } else {
            // ǡ1ĤʸѴ
            $temp = "";
            for($i=0;$i<$this->size;$i++) {
                if ( $i > 0 ) { $temp .= "\n"; }
                $temp .= intval(trim($this->data[$i]));
            }
            // ե¸
            $fp = fopen($this->path,"w");
            flock($fp,LOCK_EX);
            fwrite($fp, $temp );
            flock($fp,LOCK_UN);
            fclose($fp);
            $res = true;
        }
        return $res;
    }

    //////////////////////////////////////////////////////////////
    // 򤵤줿åNo֥ǡΰ־˰ư
    //////////////////////////////////////////////////////////////
    // ήȤƤ϶äơ־˻äƤ
    // åNoˤƤ
    // ơʳΥåNo夫֤ˤƤ
    //////////////////////////////////////////////////////////////
    //    : $no : ־˰ưоݤΥåNo
    //  : ̵
    //////////////////////////////////////////////////////////////
    public function upSelectedTurn($no = NULL) {
        if ( !is_numeric($no) )  {
            die("TURN->upSelectedTurn() : ".MESSAGE_WRONG_VALUE."(" . $no . ")");
        }

        $no = intval($no);
        $temp = array($no);
        foreach($this->data as $value ) {
            if ( $value == $no ) { continue; }
            array_push($temp,$value);
        }

        $this->data = $temp;
        return;
    }

}

?>